﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Reflection;
using System.Windows.Forms;
using Telerik.Charting;
using Telerik.WinControls.Paint;
using Telerik.WinControls.Primitives;
using Telerik.WinControls.UI;

namespace _1463681_RadChartViewScatterSeriesNull
{
    public partial class Form1 : RadForm
    {
        public Form1()
        {
            InitializeComponent();

            this.radChartView1.CreateRenderer += this.RadChartView1_CreateRenderer;
            MakeChart();
        }

        private void RadChartView1_CreateRenderer(object sender, Telerik.WinControls.UI.ChartViewCreateRendererEventArgs e)
        {
            e.Renderer = new CustomCartesianRenderer(e.Area as CartesianArea);
        }

        private DataTable _dtChart;

        private void MakeChart()
        {
            _dtChart = new DataTable("Chart");
            var column = new DataColumn("COLUMN0", typeof(DateTime));
            _dtChart.Columns.Add(column);
            column = new DataColumn("COLUMN1", typeof(double));
            _dtChart.Columns.Add(column);
            column = new DataColumn("COLUMN2", typeof(double));
            _dtChart.Columns.Add(column);
            column = new DataColumn("COLUMN3", typeof(double));
            _dtChart.Columns.Add(column);
            _dtChart.BeginLoadData();
            var row = new object[_dtChart.Columns.Count];
            var date = new DateTime(2007, 1, 1);
            row[0] = date; row[1] = 14.163764; row[2] = 13.56391907;
            _dtChart.Rows.Add(row);
            row[0] = date.AddDays(1); row[1] = 14.16415691; row[2] = 13.56490612;
            _dtChart.Rows.Add(row);
            row[0] = date.AddDays(2); row[1] = 14.16449642; row[2] = 13.56572723;
            _dtChart.Rows.Add(row);
            row[0] = date.AddDays(3); row[1] = 14.16489506; row[2] = 13.56701374;
            _dtChart.Rows.Add(row);
            row[0] = date.AddDays(4); row[1] = 14.16524887; row[2] = 13.56779575;
            _dtChart.Rows.Add(row);
            row[0] = date.AddDays(5); row[1] = 14.16561508; row[2] = 13.56877995;
            _dtChart.Rows.Add(row);
            row[0] = date.AddDays(6); row[1] = 14.1659956; row[2] = 13.56987286; row[3] = 12.9375058;
            _dtChart.Rows.Add(row);
            row[0] = date.AddDays(7); row[1] = 14.16635513; row[2] = 13.57107353; row[3] = 12.93832116;
            _dtChart.Rows.Add(row);
            row[0] = date.AddDays(8); row[1] = 14.16672421; row[2] = 13.57207203; row[3] = 12.93914642;
            _dtChart.Rows.Add(row);
            row[0] = date.AddDays(9); row[1] = 14.16709232; row[2] = 13.57329559; row[3] = 12.93998154;
            _dtChart.Rows.Add(row);
            row[0] = date.AddDays(10); row[1] = 14.1674614; row[2] = 13.57457256; row[3] = 12.94082651;
            _dtChart.Rows.Add(row);
            row[0] = date.AddDays(11); row[1] = 14.16784954; row[2] = 13.57580566; row[3] = 12.94168131;
            _dtChart.Rows.Add(row);
            row[0] = date.AddDays(12); row[1] = 14.16822338; row[2] = 13.57705879; row[3] = 12.94254593;
            _dtChart.Rows.Add(row);
            row[0] = date.AddDays(13); row[1] = 14.16857815; row[2] = 13.57775879; row[3] = 12.9441519;
            _dtChart.Rows.Add(row);
            row[0] = date.AddDays(14); row[1] = 14.16896725; row[2] = 13.57868004; row[3] = 12.94503586;
            _dtChart.Rows.Add(row);
            row[0] = date.AddDays(15); row[1] = 14.16935158; row[2] = 13.5797205; row[3] = 12.94592957;
            _dtChart.Rows.Add(row);
            row[0] = date.AddDays(16); row[1] = 14.16974831; row[2] = 13.58084583; row[3] = 12.94683301;
            _dtChart.Rows.Add(row);
            row[0] = date.AddDays(17); row[1] = 14.17011547; row[2] = 13.58196545; row[3] = 12.94774618;
            _dtChart.Rows.Add(row);
            row[0] = date.AddDays(18); row[1] = 14.17047501; row[2] = 13.58280563; row[3] = 12.94866904;
            _dtChart.Rows.Add(row);
            row[0] = date.AddDays(19); row[1] = 14.17082119; row[2] = 13.58374691; row[3] = 12.94960158;
            _dtChart.Rows.Add(row);
            row[0] = date.AddDays(20); row[1] = 14.17117214; row[2] = 13.58471298; row[3] = 12.95054378;
            _dtChart.Rows.Add(row);
            row[0] = date.AddDays(21); row[1] = 14.17156029; row[2] = 13.5856638; row[3] = 12.95149562;
            _dtChart.Rows.Add(row);
            row[0] = date.AddDays(22); row[1] = 14.17191505; row[2] = 13.58641052; row[3] = 12.95245707;
            _dtChart.Rows.Add(row);
            row[0] = date.AddDays(23); row[1] = 14.17225742; row[2] = 13.58718204; row[3] = 12.95342813;
            _dtChart.Rows.Add(row);
            row[0] = date.AddDays(24); row[1] = 14.1726265; row[2] = 13.58848; row[3] = 12.95440876;
            _dtChart.Rows.Add(row);
            row[0] = date.AddDays(25); row[1] = 14.17300701; row[2] = 13.5894928; row[3] = 12.95539896;
            _dtChart.Rows.Add(row);
            row[0] = date.AddDays(26); row[1] = 14.17333603; row[2] = 13.59065437; row[3] = 12.95639868;
            _dtChart.Rows.Add(row);
            row[0] = date.AddDays(27); row[1] = 14.17368698; row[2] = 13.5917902; row[3] = 12.95740793;
            _dtChart.Rows.Add(row);
            row[0] = date.AddDays(28); row[1] = 14.17403889; row[2] = 13.59270477; row[3] = 12.95842667;
            _dtChart.Rows.Add(row);
            row[0] = date.AddDays(29); row[1] = 14.17442799; row[2] = 13.59344292; row[3] = 12.95945488;
            _dtChart.Rows.Add(row);
            row[0] = date.AddDays(30); row[1] = 14.17476845; row[2] = 13.59449482; row[3] = 12.96049254;
            _dtChart.Rows.Add(row);
            _dtChart.EndLoadData();
            var horizontalAxis = new LinearAxis { Title = "Ln" };
            //horizontalAxis.MajorStep = .01;
            horizontalAxis.Minimum = 14.164;
            var verticalAxis = new LinearAxis
            {
                AxisType = AxisType.Second,
                Title = "Value"
            };
            //var lineSeria = new ScatterLineSeries
            //{
            //    XValueMember = "COLUMN1",
            //    YValueMember = "COLUMN2",
            //    VerticalAxis = verticalAxis,
            //    HorizontalAxis = horizontalAxis,
            //};

            //radChartView1.Series.Add(lineSeria);
            var lineSeria1 = new ScatterLineSeries
            {
                XValueMember = "COLUMN1",
                YValueMember = "COLUMN3",
                VerticalAxis = verticalAxis,
                HorizontalAxis = horizontalAxis,
            };
            radChartView1.Series.Add(lineSeria1);

            radChartView1.DataSource = _dtChart;
            radChartView1.Refresh();
        }
    }
    public class CustomCartesianRenderer : CartesianRenderer
    {
        public CustomCartesianRenderer(CartesianArea area)
            : base(area)
        { }
        protected override void Initialize()
        {
            base.Initialize();

            for (int i = 0; i < this.DrawParts.Count; i++)
            {
                ScatterLineSeriesDrawPart linePart = this.DrawParts[i] as ScatterLineSeriesDrawPart;
                if (linePart != null)
                {
                    this.DrawParts[i] = new CustomScatterLineSeriesDrawPart((ScatterLineSeries)linePart.Element, this);
                }
            }
        }
    }

    public class CustomScatterLineSeriesDrawPart : ScatterLineSeriesDrawPart
    {
        public CustomScatterLineSeriesDrawPart(ScatterLineSeries series, IChartRenderer renderer) 
            : base(series, renderer)
        {
            isEmptyFi = typeof(DataPoint).GetField("isEmpty", BindingFlags.Instance | BindingFlags.NonPublic);
        }

        FieldInfo isEmptyFi;
        protected override void DrawPoints()
        {
            PointF[] points = this.GetPointsPositionsArray();

            if (points == null)
            {
                return;
            }

            RadGdiGraphics radGraphics = new RadGdiGraphics(this.Renderer.Surface as Graphics);

            List<DataPointElement> pointElements = new List<DataPointElement>();
            DataPointElementLayoutSlotComparer comparer = new DataPointElementLayoutSlotComparer();

            if (this.Renderer is CartesianRenderer)
            {
                comparer.Vertical = ((CartesianRenderer)this.Renderer).Area.Orientation == Orientation.Vertical;
            }

            comparer.Collection = this.Element.DataPoints;

            for (int i = 0; i < this.Element.Children.Count; i++)
            {
                DataPointElement pointElement = this.Element.Children[i] as DataPointElement;
                int index = pointElements.BinarySearch(pointElement, comparer);
                pointElements.Insert(~index, pointElement);
            }

            for (int i = 0; i < pointElements.Count; i++)
            {
                DataPointElement childElement = pointElements[i] as DataPointElement;
                if (childElement == null || !childElement.IsVisible || 
                    (bool)this.isEmptyFi.GetValue((ScatterDataPoint)pointElements[i].DataPoint) || childElement.PointSize.Width < 1f || childElement.PointSize.Height < 1f)
                {
                    continue;
                }

                SizeF pointSize = childElement.PointSize;
                PointF pointLocation = points[i];

                RectangleF ptRect = new RectangleF(pointLocation, pointSize);
                ptRect.Offset(pointSize.Width / -2f, pointSize.Height / -2f);

                if (childElement.BackgroundShape != null)
                {
                    childElement.BackgroundShape.Paint((Graphics)radGraphics.UnderlayGraphics, ptRect);
                }

                GraphicsPath pointPath = null;

                if (childElement.Shape != null)
                {
                    pointPath = childElement.Shape.CreatePath(ptRect);
                }
                else
                {
                    pointPath = new GraphicsPath();
                    pointPath.AddEllipse(ptRect);
                }

                if (pointPath != null)
                {
                    FillPrimitiveImpl pointFill = new FillPrimitiveImpl(childElement, null);
                    pointFill.PaintFill(radGraphics, pointPath, ptRect);

                    BorderPrimitiveImpl pointBorder = new BorderPrimitiveImpl(childElement, null);
                    pointBorder.PaintBorder(radGraphics, null, pointPath, ptRect);

                    if (childElement.Image != null)
                    {
                        ImagePrimitiveImpl pointImage = new ImagePrimitiveImpl(childElement);
                        pointImage.PaintImage(radGraphics, childElement.Image, ptRect, childElement.ImageLayout, childElement.ImageAlignment, childElement.ImageOpacity, false);
                    }

                    pointPath.Dispose();
                }
            }
        }

        /// <summary>
        /// Gets the points positions arrays.
        /// </summary>
        /// <returns></returns>
        protected virtual List<PointF[]> GetPointsPositionsArrays()
        {
            List<PointF[]> allPoints = new List<PointF[]>();
            List<DataPoint> points = new List<DataPoint>();
            DataPointLayoutSlotComparer comparer = new DataPointLayoutSlotComparer();
            comparer.Vertical = ((CartesianRenderer)this.Renderer).Area.Orientation == Orientation.Vertical;
            comparer.Collection = this.Element.DataPoints;

            for (int i = 0; i < this.Element.Children.Count; i++)
            {
                if (!this.Element.Children[i].IsVisible || (bool)this.isEmptyFi.GetValue((ScatterDataPoint)this.Element.DataPoints[i]))
                {
                    if (points.Count > 0)
                    {
                        PointF[] slots = new PointF[points.Count];

                        for (int j = 0; j < points.Count; j++)
                        {
                            slots[j] = new PointF(this.OffsetX + (float)points[j].LayoutSlot.X,
                                this.OffsetY + (float)points[j].LayoutSlot.Y);
                        }

                        allPoints.Add(slots);
                        points = new List<DataPoint>();
                    }

                    continue;
                }

                int index = points.BinarySearch(this.Element.DataPoints[i], comparer);
                points.Insert(~index, this.Element.DataPoints[i]);
            }

            if (points.Count > 0)
            {
                PointF[] slots = new PointF[points.Count];

                for (int j = 0; j < points.Count; j++)
                {
                    slots[j] = new PointF(this.OffsetX + (float)points[j].LayoutSlot.X,
                        this.OffsetY + (float)points[j].LayoutSlot.Y);
                }

                allPoints.Add(slots);
            }

            return allPoints;
        }

        /// <summary>
        /// Draws the line.
        /// </summary>
        protected override void DrawLine()
        {
            List<PointF[]> allPoints = GetPointsPositionsArrays();
            foreach (PointF[] points in allPoints)
            {
                GraphicsPath path = GetLinePaths(points);
                if (path == null)
                {
                    continue;
                }

                RectangleF rect = ChartRenderer.ToRectangleF(this.Element.Model.LayoutSlot);
                CartesianRenderer renderer = (CartesianRenderer)this.Renderer;
                RadGdiGraphics radGraphics = new RadGdiGraphics(renderer.Graphics);

                BorderPrimitiveImpl border = new BorderPrimitiveImpl(this.Element, null);
                border.PaintBorder(radGraphics, null, path, rect);
            }
        }
        
        internal bool CheckIsEmpty(ScatterDataPoint scatterDataPoint)
        {
            return (scatterDataPoint.YValue == null || double.IsNaN(scatterDataPoint.YValue.Value));
        }
    }
}
